//============================================================================
// Config.h - Class for reading / writing a config file
//============================================================================

#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <map>
#include <string>

class CConfig
{
public:
	CConfig();
	~CConfig();

	void Reset();
	bool Load(const std::string& strFilename, char chComment='#');
	bool Save(const std::string& strFilename, const std::string& strHeader="") const;

	std::string GetValue(const std::string& strKey) const;
	void SetValue(const std::string& strKey, const std::string& strValue);

protected:
	typedef std::map<std::string, std::string> StringLookup;
	typedef StringLookup::const_iterator StringLookupIter;

	StringLookup	m_theConfig;
};

#endif // __CONFIG_H__
