//============================================================================
// ShellExecuteThread.h - Thread to process ShellExecute requests
//============================================================================

#ifndef __SHELLEXECUTETHREAD_H__
#define __SHELLEXECUTETHREAD_H__

#include <windows.h>
#include <string>

class ShellExecuteThread
{
public:
	ShellExecuteThread();
	~ShellExecuteThread();

	bool Init();

	void PostRequest(const std::string& str);

private:
	static DWORD WINAPI StaticThreadProc(LPVOID pParam);
	DWORD ThreadProc();

	HANDLE m_hThread;
	HANDLE m_hSignal;
	CRITICAL_SECTION m_cs;
	std::string m_strRequest;
	volatile bool m_bExit;
};

#endif // __SHELLEXECUTETHREAD_H__
