//============================================================================
// Main.cpp - Program entry point
//============================================================================
#include "App/App.h"


//============================================================================
static void ErrorBox(const std::string& strError)
{
	MessageBox(NULL, strError.c_str(), "Error", MB_OK | MB_ICONERROR);
}


//============================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int)
{
	// Init
	CApp* pApp = new CApp;
	if(!pApp)
	{
		ErrorBox("Out of Memory!");
		return -1;
	}
	if(!pApp->Init(hInstance))
	{
		delete pApp;
		return -1;
	}

	// Run
	pApp->Go();

	// Cleanup
	pApp->Shutdown();
	delete pApp;
	return 0;
}
