//============================================================================
// Assert.cpp - Asert statement
//============================================================================
#ifndef _CRT_SECURE_NO_WARNINGS
#	define _CRT_SECURE_NO_WARNINGS
#endif
#include <windows.h>
#include <stdio.h>

void DbgAssertFailed(const char* szExp, const char* szFile, unsigned int nLine,
	const char* szFunc, const char* szMsg, ...)
{
char szBuff[1024];

	// Trim path from filename
	if(!szFile) szFile = "??";
	const char* szRealFile = strrchr(szFile,'\\');
	if(!szRealFile) szRealFile = szFile;
	else szRealFile++;

	// Build vaargs
	va_list arg;
	va_start(arg, szMsg);
	_vsnprintf(szBuff, sizeof(szBuff), szMsg, arg);
	va_end(arg);

	// Compose string
	char szOutput[512];
	_snprintf(szOutput, sizeof(szOutput), "Assertion failed:\n"
		"%s\n"
		"\n"
		"File: %s:%d (%s)\n"
		"Expression:\n"
		"%s\n"
		"\n"
		"Debug?", szBuff, szRealFile, nLine, szFunc, szExp);

	// Display messagebox
	if(MessageBoxA(NULL, szOutput, TEXT("Assertion failed!"),
		MB_YESNO|MB_ICONEXCLAMATION) == IDYES)
	{
		__debugbreak();
	}
}
