//============================================================================
// Assert.h - Assert statement
//============================================================================

#ifndef __ASSERT_H__
#define __ASSERT_H__

#ifdef _DEBUG
#	define Assert(exp, msg, ...) \
			if (!(exp)) { \
				DbgAssertFailed(#exp, __FILE__, __LINE__, __FUNCTION__, msg, __VA_ARGS__); \
			}
#else
#	define Assert(exp, msg, ...) ((void)0)
#endif

void DbgAssertFailed(const char* szExp, const char* szFile, unsigned int nLine,
	const char* szFunc, const char* szMsg, ...);

#endif // __ASSERT_H__
