//============================================================================
// Plugin.h - Generic plugin-side header
//============================================================================

#ifndef __PLUGIN_H__
#define __PLUGIN_H__

#ifdef BUILDING_CLIENT
#	define PLUGIN_LINKAGE __declspec(dllimport)
#else
#	define PLUGIN_LINKAGE __declspec(dllexport)
#endif

#define PLUGINAPI_VERSION 2

class ScriptContext;

// Function pointer for C++ functions callable from scripts. Return false
// on error.
typedef bool (*LPScriptFunction)(ScriptContext& context, void* pParam);

// Struct filled in by exported function
struct ScriptFunction
{
	LPScriptFunction pfnFunction;
	void* pParam;
	char szName[256];
};

// Exported functions
extern "C"
{
	PLUGIN_LINKAGE size_t GetNumExportedFunctions(int nAPIVersion);
	PLUGIN_LINKAGE void GetExportedFunction(size_t nIndex, ScriptFunction& funcInfo);
};

#endif // __PLUGIN_H__
