//============================================================================
// ScriptContext.h - Context parameter passed to a user-defined function
//============================================================================

#ifndef __SCRIPTCONTEXT_H__
#define __SCRIPTCONTEXT_H__

#include "ScriptVar.h"

class ScriptContext
{
public:
	ScriptContext() {}
	virtual ~ScriptContext() {}

	//========================================================================

	// Get the number of arguments passed
	virtual size_t GetNumArgs() const = 0;

	// Get an argument at a specified index
	virtual ScriptVar GetArg(size_t nIdx) const = 0;

	// Append a return value
	virtual void AddRetval(const ScriptVar& var) = 0;

	// Set an error message to return from this function
	virtual void SetError(const char* szError) = 0;

	// Return the file extensions that this scripting library handles (without
	// the leading .) - E.g. "lua", "py", "plp"
	virtual const char* GetScriptType() = 0;
};

#endif // __SCRIPTCONTEXT_H__
