//============================================================================
// Window.h - Window base class
//============================================================================

#ifndef __WINDOW_H__
#define __WINDOW_H__

#include <windows.h>
#include <string>

//============================================================================
// Window class
class CWindow
{
public:
	CWindow();
	virtual ~CWindow() {}

	virtual bool Init(HINSTANCE hInstance);
	virtual void Shutdown();
	void Go();

protected:
	virtual LRESULT WindowProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	virtual void Tick() {}
	virtual HICON GetIcon() {return NULL;}
	virtual HCURSOR GetCursor() {return LoadCursor(NULL,IDC_ARROW);}
	virtual bool InHighPerfMode() const { return false; }
	virtual void OnNotify(NMHDR*) {}

private:
	bool PumpWindowMessages();
	static LRESULT CALLBACK StaticWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT WndProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

protected:
	HINSTANCE		m_hInstance;
	HWND			m_hWnd;
	HACCEL			m_hAccelerator;
	std::string		m_strWindowTitle;
	bool			m_bExit;
	bool			m_bActive;
	int				m_nWidth;
	int				m_nHeight;
	int				m_nXPos;
	int				m_nYPos;
};

#endif // __WINDOW_H__
