//============================================================================
// Main.cpp - Sample plugin
//============================================================================
#include "Plugin/Plugin.h"
#include "Plugin/ScriptContext.h"

//============================================================================
// This is the C function called by the script code
bool Cmd_Test(ScriptContext& context, void*)
{
	context.AddRetval(std::string("Hello world!"));
	return true;
}

//============================================================================
// Return the number of functions this plugin exports
LINKAGE size_t GetNumExportedFunctions(int nAPIVersion)
{
	// Check the plugin API version
	if(nAPIVersion != PLUGINAPI_VERSION)
		return 0;

	// We export one function
	return 1;
}

// Check version and fill in information about an exported function
LINKAGE void GetExportedFunction(size_t nIndex, ScriptFunction& funcInfo)
{
	if(nIndex == 0)
	{
		funcInfo.pfnFunction = Cmd_Test;
		funcInfo.pParam = 0;
		strcpy(funcInfo.szName, "testFunc");
	}
}

//============================================================================
