-- Autoexec.lua
-- Script that is executed when the client is started

load("Commands.lua");
load("Advproto.lua");
load("AutoLogin.lua");
load("Weather.lua");
load("Ping.lua");
load("TextUtils.lua");
load("BMP.lua");

-- Reset input field back to non-password
function reset_password_field(line)
	setPasswordInput(false);
	unregister_event("onSendLine");
	return line;
end

-- PML tag handler
function onReceivePML(tag)
	if (g_debug) then
		println("PML tag: " .. tag);
	end

	if (tag == "<username/>") then
		autoLogin()
	elseif (tag == "<password/>") then
		setPasswordInput(true);
		register_event("onSendLine", "reset_password_field");
	end
end

-- Strip TA2 tags from a string
function strip_ta2tags(tag)
	local ret = "";
	local len = string.len(tag);
	local i=1;
	while i <= len do
		local ch = string.byte(string.sub(tag, i, i));
		if(ch < 0x80) then
			ret = ret .. string.sub(tag, i, i);
		elseif(ch == 0xc4) then
			i = i + 6;
		end

		i = i+1;
	end

	return ret;
end

-- PML tag handler
function onReceive_StripTags(line)
	return strip_ta2tags(line);
end

-- Should we strip all formatting tags?
if getConfigValue("StripAllTags"):lower() == "true" then
	register_event("onReceive", "onReceive_StripTags");
end

-- Initialize the random seed
math.randomseed(getTime("u"));

register_event("onReceivePML", "onReceivePML");
